Subject: bug#65578: closed (Re: bug#65578: Eglot with mouse)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 31 Aug 2023 00:28:02 +0000

Your bug report

#65578: Eglot with mouse

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
65578: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=65578
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#65578: Eglot with mouse
From: Dmitry Gutov <[email-masked]>
To: Juri Linkov <[email-masked]>
Cc: [email-masked],João Távora <[email-masked]>
Date: Thu, 31 Aug 2023 03:27:29 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

Version: 30.1

On 30/08/2023 19:35, Juri Linkov wrote:
>>>> @@ -1637,7 +1637,9 @@ xref-find-definitions-at-mouse
>>>> -        (xref-find-definitions identifier)
>>>> +        (progn
>>>> +          (mouse-set-point event)
>>>> +          (xref-find-definitions identifier))
>>>>          (user-error "No identifier here"))))
>>> The problem with this solution is that when it doesn't find
>>> the identifier then it leaves point at the wrong place.
>> I'm not sure is a big problem, but we could save the original position and
>> restore it in case of error too:
> Thanks.  I tend to agree with João that your initial version would be
> sufficient to leave point at the position of right-clicking.
> 
> Then the same change is also needed in xref-find-references-at-mouse
> with mouse-set-point before xref-find-references.

Very good, if you don't mind the side-effect too, I've pushed the fix 
for both functions to master. And closing.

BTW, this context-menu-mode is looking pretty nifty. It'd be nice to 
turn it on by default someday.

Subject: Eglot with mouse
From: Juri Linkov <[email-masked]>
To: [email-masked]
Date: Mon, 28 Aug 2023 10:13:58 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

X-Debbugs-CC: João Távora <[email-masked]>

0. emacs -Q
1. enable context-menu-mode
2. enable eglot in a suitable buffer
3. move point to one identifier
4. click the right mouse button on another identifier
5. in the context menu click "Find Definition"

The problem is that a wrong identifier is visited.

Whereas 'xref-find-definitions-at-mouse' takes care
about getting the right identifier at the clicked position,
Eglot returns a fictitious identifier "LSP identifier at point"
that can't be used to find the identifier at the mouse click.

xref-find-definitions-at-mouse uses save-excursion with
mouse-set-point before calling xref-backend-identifier-at-point.
But the same save-excursion with mouse-set-point can't be added
around xref-find-definitions because save-excursion will restore
the original position after visiting the found identifier.

Also tried to add xref-find-definitions-at-mouse to the list
xref-prompt-for-identifier, no effect.

Then tried to remove '(xref--prompt-p this-command)'
from 'xref-backend-identifier-at-point ((_backend (eql eglot)))'.
This fixed xref-find-definitions-at-mouse, but still
doesn't work for xref-find-references-at-mouse.
Also removing '(xref--prompt-p this-command)' has such a strange effect
that it started to find approximate fuzzy matches that sound like
the original identifier.